При установке в WSL нужно сменить сменить пароль пользователя `postgres` 
```bash
$ sudo passwd postgres

# для входв в postgres
$ psql -h localhost -U postgres
```

~={yellow}Основные действия=~

```bash
# Подключение к сервер через psql
$ psql -U <user name> -h <host ip> -W -d <data base name>
```

```sql
-- Список баз данных
=> SELECT datname FROM pg_database;
-- Список баз данных в виде таблицы
=> \l

-- Список ролей
=> SELECT rolname FROM pg_roles

-- Создать роль
=> create role <name> with login password 'password';

-- Создать базу данных
=> create database <name>
	with
	template=template0
	encoding='UTF8'
	lc_collate='ru_RU.UTF-8'
	lc_ctype='ru_RU.UTF-8'
	owner <role name>
```

- `lc_collate` - Определяет порядок следование алфавита (сортировка);
- `lc_ctype` - Определяет свойства обрабатываемых символов для системы. Это определяет, какие символы рассматриваются как часть алфавита, цифры и так далее (для правильной работы с верхним и нижним регистром);
- `lc_monetary` - Определяет денежные единицы и форматирование числовых значений валюты; 
- `lc_numeric` - Определяет форматирование не денежных числовых значений. Влияет на такие вещи, как разделитель тысяч и десятичных чисел;
- `lc_time` - Определяет формат даты и времени;
- `lc_messages` - Определяет язык программных сообщений;

Настройка Postgres на сервере
https://itproblog.ru/%D0%BF%D0%B5%D1%80%D0%B2%D0%BE%D0%BD%D0%B0%D1%87%D0%B0%D0%BB%D1%8C%D0%BD%D0%B0%D1%8F-%D0%BD%D0%B0%D1%81%D1%82%D1%80%D0%BE%D0%B9%D0%BA%D0%B0-%D1%81%D0%B5%D1%80%D0%B2%D0%B5%D1%80%D0%B0-postgresql/
